
#ifdef WIN32
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#else
#include <unistd.h>
#endif

#include <string.h>
#include "StringToArgv.h"
/* #include "Gmem.h" */
char argvx[argvsize][256];
int argvcnt;


/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                           %
%         S t r i n g T o A r g v           %
%                                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  StringToArgv() converts a text string into
%  the form of command line arguments.
%
%  The format of the StringToArgv method is:
%
%      char **StringToArgv(char *text,int *argc)
%
%  A description of each parameter follows:
%
%    o argv:  Method StringToArgv returns the
%             string list unless an error
%             occurs, otherwise NULL.
%
%    o text:  Specifies the string to segment
%             into a list.
%
%    o argc:  This integer pointer returns
%             the number of arguments in the
%             list.
*/
void StringToArgv(char *text)
{
  char  c, c1, c2;
  int  i, j;
  register const char *p, *q;

  argvcnt=0;
  if (text == (char *) NULL) return;

  /*
    Determine the number of arguments.
  */
  for (p=text; *p != '\0'; )
  {
	/* skip blanks */
	while (*p == ' ' || *p == 9) p++;
	if (*p == '\0') break;

    /* skip content */
    if ((*p >= 'A' && *p <= 'z') ||
		*p <0 || 
		(*p >='0' && *p<='9')  ||
		*p == '+' || *p == '-' ||
		*p == '(' || *p == ':' ||
		*p == ',') {
				c = ' '; c1 = 9;
				c2 = ',';
	} else {
				c = *p;
				c1 = *p;
				c2 = *p;
				p++;
	}
	  q = p;
      for (p; (*p != c) && (*p != '\0') && (*p != c1) && (*p != c2); p++);

	/* find out next start */
	/*
    while (*p != ' ' &&
		   *p != ',' &&
		   *p != 9   && 
		   *p != '\0')         p++;
	*/

	/* modify 12/31/2007 */
	/* if (c!=c1) p++; */
	if (*p) p++;
	if (c==c1 && *p==',') p++;


    /* while ((*p == ' ' ||  *p == ',' || */
    while ((*p == ' ' || *p == 9) && 
		   (*p != '\0')) {
				p++;
				if (*p == ',') break;
	}
    (argvcnt)++;
  }

  if (argvcnt > argvsize) argvcnt = argvsize;
  /* Build argv array */

  p = text;
  /* skip blanks */
  while (*p == ' ' || *p == 9) p++;
  for (i=0; i < argvcnt; i++) {
	  q = p;
      /* find out content */
      if ((*p >= 'A' && *p <= 'z')
		  || *p < 0  || 
	     (*p >= '0' && *p <='9') ||
		  *p == '+' || *p == '-' ||
		  *p == '(' || *p == ':' ||
		  *p == ',') {
				c = ' '; c1 = 9;
				c2 = ',';
	  } else {
				c = *p;
				c1 = *p;
				c2 = *p;
				p++;
				q++;
	  }

	  if (*p==*(p+1) && *p==',') q++;
      else for (q; (*q != c) && (*q != '\0') && (*q != c1) && (*q != c2); q++);


	  if ((p+1) == q && *p == ',' && *q == ',') {
		  argvx[i][0] = 0;
	  } else {
		  j = q-p;
		  if (j>255) j = 255;
		  strncpy (argvx[i], p, j);	/* Copy string in */
		  argvx[i][j] = 0;
	  }

	  /* find out next start */
	  /* if (c==c1) q++; */

	  /* modify 12/31/2007
	     if (c!=c1) q++;
	     modify 2008/06/09 *correct all ',,,,,' string
	    */
	  if ((p+1) == q && *p == ',' && *q == ',') {
	  } else if (*q) q++;

	  if (c==c1 && *q==',') q++;

	  p = q;

	  /* while ((*p == ' ' ||  *p == ',' || */
	  while ((*p == ' ' || *p == 9  ) && 
			 (*p != '\0')) {
				  p++;
				  if (*p == ',') break;
	  }
	  /* if (*p != '\0') p++; */
  }
}


